<?php
namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use chillerlan\QRCode\QRCode;
// use chillerlan\QRCode\QROptions;
use Util\Utilities;
use Zeedhi\Framework\DataSource\DataSet;
use Myquest\Service\SMTP;

class ServicoController
{

    protected $entityManager;
    protected $libUtilities;
    protected $environment;
    protected $smtpService;
    private $qrCode;

    public function __construct($novoCodigo, $entityManager, $libUtilities, $environment, $smtpService)
    {
        $this->novoCodigo = $novoCodigo;
        $this->entityManager = $entityManager;
        $this->libUtilities = $libUtilities;
        $this->environment = $environment;
        $this->smtpService = $smtpService;
    }

    public function getServicos($request, $response)
    {
        $sqlCard = "SELECT NRCARDAPIO, S.IDTIPOSERV, S.CDFILIAL, S.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, S.NRORG, CASE WHEN S.HRINICSERV IS NULL AND S.HRFINASERV IS NOT NULL THEN '00:00' WHEN S.HRINICSERV IS NULL AND S.HRFINASERV IS NULL THEN NULL ELSE SUBSTR(S.HRINICSERV, 0, 2) || ':' || SUBSTR(S.HRINICSERV, 3, 2) END AS HRINICIO, CASE WHEN S.HRFINASERV IS NULL THEN NULL ELSE SUBSTR(S.HRFINASERV, 0, 2) || ':' || SUBSTR(S.HRFINASERV, 3, 2) END AS HRFINAL, CASE WHEN S.HRINICATEN IS NULL THEN NULL ELSE SUBSTR(S.HRINICATEN, 0, 2) || ':' || SUBSTR(S.HRINICATEN, 3, 2) END AS HRINICIOPREPARO, S.FGFOTOSERVICO AS IMGSERVICO, NVL(S.NRDIASANT, 0) AS NRDIASANT, NVL(S.NRDIASPOS, 0) AS NRDIASPOS, NVL(S.NRLIMSEGPEDIDO, 0) AS NRLIMSEGPEDIDO, NVL(S.HRLIMSEGPEDIDO, '0000') AS HRLIMSEGPEDIDO, S.IDRESERVASERVMYMENU, ( SELECT AVG(VRAVALIACAOSERVICO) FROM AVALIACAOSERVICO V WHERE V.CDFILIAL = S.CDFILIAL AND V.CDSERVFILI = S.CDSERVFILI AND V.VRAVALIACAOSERVICO IS NOT NULL ) AS AVG_SERVICO, ( SELECT MAX(IDRESERVAMYMENU) FROM TABLE ( PRATOS_MYMENU(NULL, NULL, S.CDFILIAL, S.CDSERVFILI, 'N', NULL, :DTCARDAPIO, :NRORG) ) ) AS RESERVA_PRATO FROM SERVICO S INNER JOIN CARDADIA C ON C.CDFILIAL = S.CDFILIAL AND C.CDSERVFILI = S.CDSERVFILI AND C.DTCARDAPIO = :DTCARDAPIO AND C.DTCARDAPIO BETWEEN TRUNC(SYSDATE) - NVL(S.NRDIASANT, 0) AND TRUNC(SYSDATE) + NVL(S.NRDIASPOS, 0) LEFT JOIN SERVICOLOCALPESQ SLP ON SLP.CDFILIAL = S.CDFILIAL AND SLP.NRLOCALPESQ = :NRLOCALPESQ WHERE S.IDDISPONIVELMYMENU = 'S' AND S.CDFILIAL = :CDFILIAL AND ( CASE WHEN EXISTS ( SELECT SLPQ.CDSERVFILI FROM SERVICOLOCALPESQ SLPQ WHERE SLPQ.NRLOCALPESQ = :NRLOCALPESQ AND SLPQ.CDFILIAL = :CDFILIAL ) THEN SLP.CDSERVFILI ELSE S.CDSERVFILI END ) = S.CDSERVFILI AND S.NRORG = :NRORG AND ( EXISTS ( SELECT CP.NRCARDAPIO FROM COMPCARD CP WHERE CP.CDFILIAL = C.CDFILIAL AND CP.NRCARDAPIO = C.NRCARDAPIO ) OR EXISTS ( SELECT CPP.NRCARDAPIO FROM COMPCARDPESQ CPP WHERE CPP.CDFILIAL = C.CDFILIAL AND CPP.NRCARDAPIO = C.NRCARDAPIO AND CPP.IDEXIBEPRATOPESQ = 'S' ) ) ORDER BY CDSERVFILI";
        $sqlTelao = "SELECT S.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, NVL(TP.NMFANTASIATP, P.NMTIPOPRAT) AS AGRUPADOR ,P.NMPRATO AS NOME, P.DSPRATO AS DESCRICAO, P.IDGLUTEN, P.IDLACTOSE, CASE WHEN P.CALORIAS_KCAL IS NULL THEN NULL ELSE 'Kcal: '||TO_CHAR(P.CALORIAS_KCAL,'FM9999999990.90') END AS VALOR, P.URL_FOTOPRATO AS URL_FOTO, TO_NUMBER(NRORDPRATCAR) AS NRORDEM FROM SERVICO S LEFT JOIN SERVICOLOCALPESQ SLP ON SLP.CDFILIAL = S.CDFILIAL AND SLP.NRLOCALPESQ = :NRLOCALPESQ, TABLE(PRATOS_MYMENU(NULL, NULL, S.CDFILIAL, S.CDSERVFILI, 'N', NULL, :DTCARDAPIO, :NRORG, :NRLOCALPESQ, 'N')) P, TIPOPRAT TP WHERE S.IDDISPONIVELMYMENU = 'S' AND S.CDFILIAL = :CDFILIAL AND S.NRORG = :NRORG AND(NVL(SLP.CDSERVFILI, S.CDSERVFILI) = S.CDSERVFILI) AND P.CDPRATO IS NOT NULL AND TP.CDTIPOPRAT = P.CDTIPOPRAT AND (TO_CHAR(SYSDATE, 'HH24MI') BETWEEN NVL(S.HRINICSERV, '0000') AND NVL(S.HRFINASERV, '2359')) UNION ALL SELECT '' AS CDSERVFILI, '_' AS NMSERVICO, G.NMGRUPOPRATOPESQ AS AGRUPADOR, NVL(P.NMFANTPRODUTO,P.NMPRODUTO) AS NOME, PL.DSDESCRICAO AS DESCRICAO, NVL2((SELECT MAX(A.CDPRODUTO) FROM ALERGENICOPROD A INNER JOIN PARAMGERAL P ON P.NRGLUTEN = A.NRALERGENICO WHERE A.CDPRODUTO = PL.CDPRODUTO AND P.CDPARGERAL = '0001'),'S','N') AS IDGLUTEN, NVL2((SELECT MAX(A.CDPRODUTO) FROM ALERGENICOPROD A INNER JOIN PARAMGERAL P ON P.NRLACTOSE = A.NRALERGENICO WHERE A.CDPRODUTO = PL.CDPRODUTO AND P.CDPARGERAL = '0001'),'S','N') AS IDLACTOSE, TO_CHAR(PL.VRPRECO, 'FM9999999990.90') AS VALOR, PL.URL_FOTO, PL.NRORDEM FROM PRODUTOLOCALPESQ PL INNER JOIN PRODUTO P ON PL.CDPRODUTO = P.CDPRODUTO INNER JOIN GRUPOPRATOPESQ G ON PL.NRGRUPOPRATOPESQ = G.NRGRUPOPRATOPESQ WHERE PL.NRLOCALPESQ = :NRLOCALPESQ AND PL.IDEXIBE = 'S' AND :EXIBEPROD = 'S' ORDER BY CDSERVFILI ASC, NRORDEM ASC";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();

        $paramsCard  = ['NRORG' => $row['NRORG'], 'CDFILIAL' => $row['CDFILIAL'], 'DTCARDAPIO' => $row['DTCARDAPIO'], 'NRLOCALPESQ' => $row['NRLOCALPESQ']];
        $paramsTelao = ['NRORG' => $row['NRORG'], 'CDFILIAL' => $row['CDFILIAL'], 'DTCARDAPIO' => $row['DTCARDAPIO'], 'NRLOCALPESQ' => $row['NRLOCALPESQ'], 'EXIBEPROD' => $row['EXIBEPROD']];

        $sql = isset($row['TELAO']) && $row['TELAO'] == 'S' ? $sqlTelao : $sqlCard;
        $params = isset($row['TELAO']) && $row['TELAO'] == 'S' ? $paramsTelao : $paramsCard;

        $statement = $conn->prepare($sql);
        $statement->execute($params);

        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('servico', $result));
    }

    public function insertReservaServico($request, $response)
    {
        try {
            $sql = "INSERT INTO AVALIACAOSERVICO (NRAVALIACAOSERVICO, IDCONSUMO, CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, NRORG, NMUSUARIO, DSCONSUMO, HRCONSUMO, NRLOCALPESQ, CDREGISTROPESSOA, NRUSUARIOAPP, IDSTATUSRESERVA) VALUES (:NRAVALIACAOSERVICO, :IDCONSUMO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :DTCARDAPIO, :NRORG, :NMUSUARIO, :DSCONSUMO, :HRCONSUMO, :NRLOCALPESQ, :CDREGISTROPESSOA, :NRUSUARIOAPP, 'AGENDADO')";
            $conn = $this->entityManager->getConnection();
            $row = $request->getRow();
            
            $NRAVALIACAOSERVICO = $this
                            ->novoCodigo
                            ->getCodeByTableName('AVALIACAOSERVICO', $row['NRORG'], 1, 10, false);
            $params = [
                'NRAVALIACAOSERVICO'=> $NRAVALIACAOSERVICO,
                'IDCONSUMO'         => "S",
                'CDFILIAL'          => $row['CDFILIAL'],
                'CDSERVFILI'        => $row['CDSERVFILI'],
                'NRCARDAPIO'        => $row['NRCARDAPIO'],
                'DTCARDAPIO'        => $row['DTCARDAPIO'],
                'NRORG'             => $row['NRORG'],
                'NMUSUARIO'         => $row['NMUSUARIO'],
                'DSCONSUMO'         => $row['DSCONSUMO'],
                'HRCONSUMO'         => $row['HRCONSUMO'],
                'NRLOCALPESQ'       => $row['NRLOCALPESQ'],
                'CDREGISTROPESSOA'  => $row['CDREGISTROPESSOA'],
                'NRUSUARIOAPP'      => $row['NRUSUARIOAPP']
            ];
    
            $statement = $conn->prepare($sql);
    
            $statement->execute($params);  
            $result = [
                'NRORG'              => $row['NRORG'],
                'type'               => 'S',
                'NRAVALIACAOSERVICO' => $NRAVALIACAOSERVICO
            ];
            $response->addDataSet(new DataSet('data', $result));
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function sendReservServiceMail($request, $response) {
        $row = $request->getRow();
        $body = $this->constructServiceEmail($row);
        $address = $row['DSEMAILUSUARIOAPP'];
        $this->smtpService->setSubject('Dados da reserva.');
        // caso seja necessário no futuro enviar algo por anexo, apenas seguir o exemplo abaixo
        // $this->smtpService->addAttachment(__DIR__ . "/../Templates/myQuestLogo.png", 'QrCode Reserva');
        // Caso não encontre no banco, usa os mnemonicos
        $smtpParametros = $this->getFilial($row);
        if(!empty($smtpParametros)){
            $paramsAux = Utilities::getSmtpSettingsFromAddress($smtpParametros['host']);
            $smtpParametros['host'] = $paramsAux['host'];
            $smtpParametros['port'] = $paramsAux['port'] ?? null;
            $smtpParametros['password'] = ($smtpParametros['password']) ? Utilities::getDelphiPasswordEncrypted($smtpParametros['password'], false) : '';
            $SMTPServiceAux = new SMTP($smtpParametros);
            $this->smtpService = $SMTPServiceAux;
        }
        $this->smtpService->sendMail($body, $address);   
    }
    
    private function getFilial($row){

        $query = "
               SELECT 
                NVL(DSLOGINSMTP, DSEMAILFILI) AS username,
                DSSMTPEMAILF AS host,
                CDSENHEMAILF AS password,
                CASE
                    WHEN IDUTTLSEMAIL = 'S' 
                    THEN 'tls' 
                    WHEN IDUTSSLEMAIL = 'S' 
                    THEN 'ssl' 
                    ELSE '' 
                END AS smtpSecure, 
                NVL(DSEMAILFILI, DSLOGINSMTP) AS email_From,
                CASE 
                    WHEN NVL(DSLOGINSMTP, DSEMAILFILI) IS NOT NULL AND 
                    CDSENHEMAILF IS NOT NULL 
                    THEN 'S' 
                    ELSE 'N' 
                    END AS auth
                FROM ENDEFILI 
                WHERE CDFILIAL = :CDFILIAL 
                AND IDTPENDEFILI = 'P' AND
                DSSMTPEMAILF IS NOT NULL
        ";
        
        
        $params = [
            "CDFILIAL" => $row['CDFILIAL']
        ];
        
        try{
            $conn = $this->entityManager->getConnection();
            $std = $conn->prepare($query);
            $std->execute($params);
            $rowResult = $std->fetch();
            
            if(!empty($rowResult)){
                $rowResult['username'] = $rowResult['USERNAME'];
                $rowResult['host'] = $rowResult['HOST'];
                $rowResult['password'] = $rowResult['PASSWORD'];
                $rowResult['smtpSecure'] = $rowResult['SMTPSECURE'];
                $rowResult['from'] = $rowResult['EMAIL_FROM'];
                $rowResult['smtpAuth'] = $rowResult['AUTH'];
                    
                unset($rowResult['USERNAME']);
                unset($rowResult['HOST']);
                unset($rowResult['PASSWORD']);
                unset($rowResult['SMTPSECURE']);
                unset($rowResult['EMAIL_FROM']);
                unset($rowResult['AUTH']);
                
                if($rowResult['smtpAuth'] == 'S')
                    $rowResult['smtpAuth'] = true;
                else
                    $rowResult['smtpAuth'] = false;
            }
            return $rowResult;
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function constructServiceEmail($row) {
        $name = $row['NMUSUARIO'];
        $service = $row['NMSERVICO'];
        $serviceDate = $row['DTCARDAPIO'];
        $serviceTime = substr($row['HRCONSUMO'], 0, 2) . ":" . substr($row['HRCONSUMO'], 2);
        if ($row['digitalReservation'] === 'true') {
            $data = $row['NRORG'] . ',' . $row['type'] . ',' . $row['NRAVALIACAOSERVICO'];
            $qrCodeBase64 = (new QRCode)->render($data);
            $qrCode = '<img src="'.$qrCodeBase64.'" alt="QR Code" />';
        } else {
            $qrCode = '';
        }
        switch ($row['lang']) {
            case 'pt-br':
                $mailTemplate = file_get_contents(__DIR__ . "/../Templates/reservation-servicePT-mail.html");
                if ($row['digitalReservation'] === 'true') {
                    $footerMessage = 'Para realizar a retirada do seu pedido informe seu CPF cadastrado na reserva ou faça a leitura do Qr-Code abaixo no aplicativo MyQuest, disponibilizado no restaurante.';
                } else {
                    $footerMessage = '';
                }
                break;
            case 'en-us':
                $mailTemplate = file_get_contents(__DIR__ . "/../Templates/reservation-serviceEN-mail.html");
                if ($row['digitalReservation'] === 'true') {
                    $footerMessage = 'To collect your order, enter your ID number registered when booking or scan the Qr-Code below in the MyQuest application, available in the restaurant.';
                } else {
                    $footerMessage = '';
                }
                break;
            case 'es-es':
                $mailTemplate = file_get_contents(__DIR__ . "/../Templates/reservation-serviceES-mail.html");
                if ($row['digitalReservation'] === 'true') {
                    $footerMessage = 'Para recoger tu pedido introduce tu número de ID registrado al hacer la reserva o escanea el código Qr que aparece a continuación en la aplicación MyQuest, disponible en el restaurante.';
                } else {
                    $footerMessage = '';
                }
                break;
            default:
                $mailTemplate = file_get_contents(__DIR__ . "/../Templates/reservation-servicePT-mail.html");
                if ($row['digitalReservation'] === 'true') {
                    $footerMessage = 'Para realizar a retirada do seu pedido informe seu CPF cadastrado na reserva ou faça a leitura do Qr-Code abaixo no aplicativo MyQuest, disponibilizado no restaurante.';
                } else {
                    $footerMessage = '';
                }
                break;
        }
        $logo = $row['logo'];
        $content = mb_convert_encoding($mailTemplate, 'UTF-8', mb_detect_encoding($mailTemplate, 'UTF-8, ISO-8859-1', true));
        $search = array(
            "%logo%",
            "%name%",
            "%service%",
            "%serviceDate%",
            "%serviceTime%",
            "%footerMessage%",
            "%qrCode%",
        );
        $replace = array(
            $logo,
            $name,
            $service,
            $serviceDate,
            $serviceTime,
            $footerMessage,
            $qrCode,
        );
        
        return str_replace($search, $replace, $content);
    }

    protected function executeInsertSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }

    public function rateService($request, $response){
        $sql = "INSERT INTO AVALIACAOSERVICO (NRAVALIACAOSERVICO, IDCONSUMO, CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, NRORG, NRLOCALPESQ, VRAVALIACAOSERVICO) VALUES (:NRAVALIACAOSERVICO, :IDCONSUMO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :DTCARDAPIO, :NRORG, :NRLOCALPESQ, :VRAVALIACAOSERVICO)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $NRAVALIACAOSERVICO = $this
                        ->novoCodigo
                        ->getCodeByTableName('AVALIACAOSERVICO', $row['NRORG'], 1, 10, false);
        $params = [
            'NRAVALIACAOSERVICO' => $NRAVALIACAOSERVICO,
            'IDCONSUMO' => "N",
            'CDFILIAL' => $row['CDFILIAL'],
            'CDSERVFILI' => $row['CDSERVFILI'],
            'NRCARDAPIO' => $row['NRCARDAPIO'],
            'DTCARDAPIO' => $row['DTCARDAPIO'],
            'NRORG' => $row['NRORG'],
            'NRLOCALPESQ' => $row['NRLOCALPESQ'],
            'VRAVALIACAOSERVICO' => $row['rateValue']
        ];

        $statement = $conn->prepare($sql);

        $statement->execute($params);
    }
    
    public function setDadosColetados($dadosLogin){
        $rows = $dadosLogin->getRow();
        $cdfilial = $rows['CDFILIAL'];
        $nrorg = $rows['NRORG'];
        $cdoperador = $rows['CDOPERADOR'];
        
        //Path productid = /myquest/productInfo.json
        $productId = 2472;
        
        $this->libUtilities->saveCollectedData($cdfilial,'MYQUEST', $productId, $cdoperador, null, $nrorg );
    }
    
    public function checkUserIdNumber($request, $response){
        $sql = "SELECT TO_CHAR(DTULTATU, 'DD/MM/YYYY HH24:MM:SS') AS ULTATU, NRUSUARIOAPP, CDREGISTROPESSOA, DSEMAILUSUARIOAPP, DSPRIMEIRONOME, DSULTIMONOME, DSSETOR, COUNT(NRUSUARIOAPP) OVER(PARTITION BY CDREGISTROPESSOA, DSEMAILUSUARIOAPP) AS QTUSUARIOS FROM USUARIOAPP WHERE UPPER(DSEMAILUSUARIOAPP) = UPPER(:DSEMAIL) OR CDREGISTROPESSOA = :CPF ORDER BY DTULTATU DESC";
        $conn = $this->entityManager->getConnection();
        $row = $request->getRow();
        
        $params = [
            'DSEMAIL' => null,
            'CPF'     => $row['CPF']
        ];
        
        $statement = $conn->prepare($sql);
        $statement->execute($params);
        
        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('userData', $result));
    }
    
    public function checkUserEmail($request, $response){
        $sql = "SELECT TO_CHAR(DTULTATU, 'DD/MM/YYYY HH24:MM:SS') AS ULTATU, NRUSUARIOAPP, CDREGISTROPESSOA, DSEMAILUSUARIOAPP, DSPRIMEIRONOME, DSULTIMONOME, DSSETOR, COUNT(NRUSUARIOAPP) OVER(PARTITION BY CDREGISTROPESSOA, DSEMAILUSUARIOAPP) AS QTUSUARIOS FROM USUARIOAPP WHERE UPPER(DSEMAILUSUARIOAPP) = UPPER(:DSEMAIL) OR CDREGISTROPESSOA = :CPF ORDER BY DTULTATU DESC";
        $conn = $this->entityManager->getConnection();
        $row = $request->getRow();
        
        $params = [
            'DSEMAIL' => $row['DSEMAIL'],
            'CPF'     => null
        ];
        
        $statement = $conn->prepare($sql);
        $statement->execute($params);
        
        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('userData', $result));
    }
    
    public function registerNewUser($request, $response) {
        $sqlInsert = "INSERT INTO USUARIOAPP ( NRUSUARIOAPP, CDREGISTROPESSOA, DSEMAILUSUARIOAPP, DSPRIMEIRONOME, DSULTIMONOME, DSSETOR ) VALUES (:NRUSUARIOAPP, :CPF, :DSEMAIL, :PRIMEIRONOME, :ULTIMONOME, :DSSETOR )";
        $sqlUpdate = "UPDATE USUARIOAPP SET CDREGISTROPESSOA = :CPF, DSEMAILUSUARIOAPP = :DSEMAIL, DSPRIMEIRONOME = :PRIMEIRONOME, DSULTIMONOME = :ULTIMONOME, DSSETOR = :DSSETOR WHERE NRUSUARIOAPP = :NRUSUARIOAPP";
        $conn = $this->entityManager->getConnection();
        $row = $request->getRow();
        
        $NRUSUARIOAPP = $this
                ->novoCodigo
                ->getCodeByTableName('USUARIOAPP', $row['NRORG'], 1, 10, false);
        
        $sql = $row['newUser'] ? $sqlInsert : $sqlUpdate;
        
        $paramsInsert = ['DSEMAIL' => $row['DSEMAIL'], 'CPF' => $row['CPF'], 'ULTIMONOME' => $row['ULTIMONOME'], 'PRIMEIRONOME' => $row['PRIMEIRONOME'], 'DSSETOR' => $row['DSSETOR'], 'NRUSUARIOAPP' => $NRUSUARIOAPP];
        $paramsUpdate = ['DSEMAIL' => $row['DSEMAIL'], 'CPF' => $row['CPF'], 'ULTIMONOME' => $row['ULTIMONOME'], 'PRIMEIRONOME' => $row['PRIMEIRONOME'], 'DSSETOR' => $row['DSSETOR'], 'NRUSUARIOAPP' => $row['NRUSUARIOAPP']];
        
        $params = $row['newUser'] ? $paramsInsert : $paramsUpdate;
        
        $statement = $conn->prepare($sql);

        $statement->execute($params);
    }
    
}