<?php

/**
 * 01/06/2015
 * @author Francis
 */

namespace Myquest\Service;

use \Myquest\Libraries\PHPMailer;

class SMTP
{

    private $SMTPAuth    = true;
    private $IsHTML      = true;
    private $Host;
    private $Username;
    private $Password;
    private $Port;
    private $SMTPSecure;    
    private $From;
    private $FromName    = "SAC MyQuest";
    private $NmAddress   = "SAC MyQuest";
    private $Subject     = "SAC MyQuest";
    private $Attachments = array();

    public function __construct(array $params = array())
    {
        $this->Host       = isset($params['host']) ? $params['host'] : "smtp.teknisa.com";
        $this->Username   = isset($params['username']) ? $params['username'] : "app@tecfood.com";
        $this->Password   = isset($params['password']) ? $params['password'] : "@AppTecFood2015";
        $this->Port       = isset($params['port']) ? $params['port'] : "";
        $this->SMTPSecure = isset($params['smtpSecure']) ? $params['smtpSecure'] : "";
        $this->From       = isset($params['from']) ? $params['from'] : "no-reply@teknisa.com";
    }

    public function sendMail($message, $address)
    {
        $mail           = new PHPMailer;
        $mail->CharSet  = 'UTF-8';
        $mail->IsHTML($this->IsHTML);
        $mail->isSMTP(); // Set mailer to use SMTP
        $mail->Host       = $this->Host; // Specify main and backup SMTP servers
        $mail->SMTPAuth   = $this->SMTPAuth; // Enable SMTP authentication
        $mail->Username   = $this->Username; // SMTP username
        $mail->Password   = $this->Password; // SMTP password
        $mail->Port       = $this->Port;
        $mail->SMTPSecure = $this->SMTPSecure;        
        $mail->From       = $this->From;
        $mail->FromName   = $this->FromName;
        $mail->Subject    = $this->Subject;
        $mail->Body       = $message;

        if (is_array($address)) {
            foreach ($address as $to) {
                $mail->addAddress($to, $to); // Add multiple recipients
            }
        } else {
            $mail->addAddress($address, $this->NmAddress); // Add a recipient
        }

        foreach ($this->Attachments as $attachment) {
            // Add all attachments
            $mail->addAttachment($attachment["path"], $attachment["name"], $attachment["encoding"], $attachment["type"], $attachment["disposition"]);
        }

        $mail->send();
    }

    public function sendNewFaleConoscoNotification($notificationData)
    {
        $address = $notificationData['emailContato'];

        $mail           = new PHPMailer;
        $mail->CharSet  = 'UTF-8';
        $mail->IsHTML($this->IsHTML);
        $mail->isSMTP(); // Set mailer to use SMTP
        $mail->Host     = $this->Host; // Specify main and backup SMTP servers
        $mail->SMTPAuth = $this->SMTPAuth; // Enable SMTP authentication
        $mail->Username = $this->Username; // SMTP username
        $mail->Password = $this->Password; // SMTP password
        $mail->From     = $this->From;
        $mail->FromName = $this->FromName;
        $mail->Subject  = $this->Subject;
        $mail->Body     = 'Um novo fale conosco foi recebido, pelo MYMENU, de '. 
                          $notificationData['enviadoPor'] .
                          ' com a seguinte menssagem: "'. 
                          $notificationData['menssagem'] .
                          '". Acesse o sistema TecFood para maiores detalhes.';

        $mail->addAddress($address, 'Fale Conosco Mymenu'); // Add a recipient
        $mail->send();
    }

    public function setHost($Host)
    {
        $this->Host = $Host;
    }

    public function setSMTPAuth($SMTPAuth)
    {
        $this->SMTPAuth = $SMTPAuth;
    }

    public function setUsername($Username)
    {
        $this->Username = $Username;
    }

    public function setIsHTML($IsHTML)
    {
        $this->IsHTML = $IsHTML;
    }

    public function setPassword($Password)
    {
        $this->Password = $Password;
    }

    public function setFrom($From)
    {
        $this->From = $From;
    }

    public function setFromName($FromName)
    {
        $this->FromName = $FromName;
    }

    public function setNmAddress($NmAddress)
    {
        $this->NmAddress = $NmAddress;
    }

    public function setSubject($Subject)
    {
        $this->Subject = $Subject;
    }

    public function addAttachment($path, $name = '', $encoding = 'base64', $type = '', $disposition = 'attachment')
    {
        $this->Attachments[] = array(
            "path"        => $path,
            "name"        => $name,
            "encoding"    => $encoding,
            "type"        => $type,
            "disposition" => $disposition,
        );
    }

}
